# class rclip

Remote ClipBoard services via PLP More...

Definition | `#include <rclip.h>`
List of all Methods

Annotated List
Files
Globals
Hierarchy
Index

#### Public Methods

- rclip (ppsocket *skt)
- ~rclip ()
- void reset ()
- void reconnect ()
- Enum<rfsv::errs> getStatus ()
- Enum<rfsv::errs> initClipbd ()
- Enum<rfsv::errs> sendListen ()
- Enum<rfsv::errs> checkNotify ()
- Enum<rfsv::errs> waitNotify ()
- Enum<rfsv::errs> notify ()

#### Protected Types

- enum commands { RCLIP_INIT = 0x00, RCLIP_NOTIFY = 0x08, RCLIP_LISTEN = 0x04 }

#### Protected Methods

- bool sendCommand (enum commands cc)
- Enum<rfsv::errs> getResponse (bufferStore &data)
- const char * getConnectName ()

#### Protected Members

- ppsocket *skt
- Enum<rfsv::errs> status

## Detailed Description

Remote ClipBoard services via PLP

This class implements access to the remote clipboard notification feature of the Psion. The Psion uses a file C:\System\Data\Clpboard.cbd for storing the content of its clipboard. This file can be accessed like any other regular file on the Psion using the rfsv implementation. This class handles notification about changes of this file. There are two methods of notification implemented. Using waitNotify , a blocking method can be used and using sendListen followed by checkNotify , a polling approach (usable for GUI programs) can be implemented.

rclip (ppsocket *skt)

### rclip

Constructs a new rclip object.

Parameters:

skt | The socket to be used by this object.

~rclip ()

### ~rclip

destructor.

void reset ()

### reset

Initializes a connection to the remote machine.

void reconnect ()

### reconnect

Attempts to re-establish a remote connection by first closing the socket, then connecting again to the ncpd daemon and finally calling reset.

Enum<rfsv::errs> getStatus ()

### getStatus

Retrieves the current status of the connection.

Returns: The connection status.

Enum<rfsv::errs> initClipbd ()

### initClipbd

Send initialization frame.

Must be called once after a new rclip object has be called. It sends an initialzation frame to the Psion's server and returns its status.

Returns: The connection status.

Enum<rfsv::errs> sendListen ()

### sendListen

Send listen request.

Calling this method arms the Psion's clipboard server. After that, every change of the Psion's clipboard file will be signaled. To poll the signal, subsequent calls to checkNotify should be made.

Returns: The connection status.

Enum<rfsv::errs> checkNotify ()

### checkNotify

Check for clipboard notification.

If the Psion has sent a notification, this method returns rfsv::E_PSI_GEN_NONE . If there is no notification pending, this method returns rfsv::E_PSI_FILE_EOF All other return values are to be treated as errors

Returns: The connection status.

Enum<rfsv::errs> waitNotify ()

### waitNotify

Send listen request and wait for notification.

This method is the blocking version of the two above methods. It first sends a listen request and then blocks until a notification has sent by the Psion or an error occured.

Returns: The connection status, rfsv::E_PSI_GEN_NONE if a notification has been received.

Enum<rfsv::errs> notify ()

### notify

Send a notification to the Psion.

If the application wishes to notify the Psion after changing the clipboard file, this method can be used.

Returns: The connection status.

enum commands { RCLIP_INIT = 0x00, RCLIP_NOTIFY = 0x08, RCLIP_LISTEN = 0x04 }

### commands

[protected]

The possible commands.

ppsocket * skt

### skt

[protected]

Enum<rfsv::errs> status

### status

[protected]

bool sendCommand (enum commands cc)

### sendCommand

[protected]

Sends a command to the remote side.

If communication fails, a reconnect is triggered and a second attempt to transmit the request is attempted. If that second attempt fails, the function returns an error an sets rpcs::status to E_PSI_FILE_DISC.

Parameters:

cc | The command to execute on the remote side.
data | Additional data for this command.

Returns: true on success, false on failure.

Enum<rfsv::errs> getResponse (bufferStore &data)

### getResponse

[protected]

const char * getConnectName ()

### getConnectName

[protected]

Generated by: rrt on drom on Mon Nov 26 16:06:15 2007, using kdoc 2.0a54.